---
title: Keyframe Formats
slug: Web/API/Web_Animations_API/Keyframe_Formats
tags:
  - API
  - Animation
  - Experimental
  - KeyframeEffect()
  - Reference
  - animate()
  - setKeyframes()
  - waapi
  - web animations api
---
<p>{{ SeeCompatTable() }}{{ APIRef("Web Animations API") }}</p>

<p>{{domxref("Element.animate()")}}, {{domxref("KeyframeEffect.KeyframeEffect()")}}, and {{domxref("KeyframeEffect.setKeyframes()")}} all accept objects formatted to represent a set of keyframes. There are several options to this format, which are explained below.</p>

<h2 id="Syntax">Syntax</h2>

<div id="keyframe-syntax">
<p>There are two different ways to format keyframes:</p>

<ol>
 <li>
  <p>An <code>array</code> of objects (keyframes) consisting of properties and values to iterate over. This is the canonical format returned by the {{domxref("KeyframeEffect.getKeyframes()", "getKeyframes()")}} method.</p>

  <pre class="brush: js"><em>element</em>.animate(<strong>[
  { // from
    opacity: 0,
    color: "#fff"
  },
  { // to
    opacity: 1,
    color: "#000"
  }
]</strong>, 2000);</pre>

  <p>Offsets for each keyframe can be specified by providing an <code>offset</code> value.</p>

  <pre class="brush: js"><em>element</em>.animate(<strong>[ { opacity: 1 },
                  { opacity: 0.1, offset: 0.7 },
                  { opacity: 0 } ]</strong>,
                2000);
</pre>

  <div class="note">
  <p><strong>Note</strong>: <code>offset</code> values, if provided, must be between 0.0 and 1.0 (inclusive) and arranged in ascending order.</p>
  </div>

  <p>It is not necessary to specify an offset for every keyframe. Keyframes without a specified offset will be evenly spaced between adjacent keyframes.</p>

  <p>The easing to apply between keyframes can be specified by providing an <code>easing</code> value as illustrated below.</p>

  <pre class="brush: js"><em>element</em>.animate(<strong>[ { opacity: 1, easing: 'ease-out' },
                  { opacity: 0.1, easing: 'ease-in' },
                  { opacity: 0 } ]</strong>,
                2000);
</pre>

  <p>In this example, the specified easing only applies from the keyframe where it is specified until the next keyframe. Any <code>easing</code> value specified on the <code>options</code> argument, however, applies across a single iteration of the animation — for the entire duration.</p>
 </li>
 <li>
  <p>An <code>object</code> containing key-value pairs consisting of the property to animate and an <code>array</code> of values to iterate over.</p>

  <pre class="brush: js"><em>element.</em>animate(<strong>{
  opacity: [ 0, 1 ],          // [ from, to ]
  color:   [ "#fff", "#000" ] // [ from, to ]
}</strong>, 2000);
</pre>

  <p>Using this format, the number of elements in each array does not need to be equal. The provided values will be spaced out independently.</p>

  <pre class="brush: js"><em>element.</em>animate(<strong>{
  opacity: [ 0, 1 ], // offset: 0, 1
  backgroundColor: [ "red", "yellow", "green" ], // offset: 0, 0.5, 1
}</strong>, 2000);
</pre>

  <p>The special keys <code>offset</code>, <code>easing</code>, and <code>composite</code> (described below) may be specified alongside the property values.</p>

  <pre class="brush: js"><em>element.</em>animate(<strong>{
  opacity: [ 0, 0.9, 1 ],
  offset: [ 0, 0.8 ], // Shorthand for [ 0, 0.8, 1 ]
  easing: [ 'ease-in', 'ease-out' ],
}</strong>, 2000);
</pre>

  <p>After generating a suitable set of keyframes from the property value lists, each supplied offset is applied to the corresponding keyframe. If there are insufficient values, or if the list contains <code>null</code> values, the keyframes without specified offsets will be evenly spaced as with the array format described above.</p>

  <p>If there are too few <code>easing</code> or <code>composite</code> values, the corresponding list will be repeated as needed.</p>
 </li>
</ol>

<h3 id="Implicit_tofrom_keyframes">Implicit to/from keyframes</h3>

<p>In newer browser versions, you are able to set a beginning or end state for an animation only (i.e. a single keyframe), and the browser will infer the other end of the animation if it is able to. For example, consider <a href="https://mdn.github.io/dom-examples/web-animations-api/implicit-keyframes.html">this simple animation</a> — the Keyframe object looks like so:</p>

<pre class="brush: js">let rotate360 = [
  { transform: 'rotate(360deg)' }
];</pre>

<p>We have only specified the end state of the animation, and the beginning state is implied.</p>

<h2 id="Attributes">Attributes</h2>

<p>Keyframes may specify property-value pairs for any of the {{cssxref("CSS_animated_properties", "animatable CSS properties")}}. The property names are specified using camel-case so for example {{cssxref("background-color")}} becomes <code>backgroundColor</code> and {{cssxref("background-position-x")}} becomes <code>backgroundPositionX</code>. Shorthand values such as {{cssxref("margin")}} are also permitted.</p>

<p>Two exceptional CSS properties are:</p>

<ul>
 <li>{{cssxref("float")}}, which must be written as <code>cssFloat</code> since "float" is a reserved word in JavaScript. It's just for reference here, this will have no effect on animation since "float" is not an animatable CSS property.</li>
 <li>{{cssxref("offset")}}, which must be written as <code>cssOffset</code> since "offset" represents the keyframe offset as described below.</li>
</ul>

<p>The following special attributes may also be specified:</p>

<dl>
 <dt>offset</dt>
 <dd>
 <p>The offset of the keyframe specified as a number between <code>0.0</code> and <code>1.0</code> inclusive or <code>null</code>. This is equivalent to specifying start and end states in percentages in CSS stylesheets using <code>@keyframes</code>. If this value is <code>null</code> or missing, the keyframe will be evenly spaced between adjacent keyframes.</p>
 </dd>
 <dt>easing</dt>
 <dd>
 <p>The <a href="/en-US/docs/Web/CSS/timing-function">timing function</a> used from this keyframe until the next keyframe in the series.</p>
 </dd>
 <dt>composite</dt>
 <dd>
 <p>The {{domxref("KeyframeEffect.composite")}} operation used to combine the values specified in this keyframe with the underlying value. This will be <code>auto</code> if the composite operation specified on the effect is being used.</p>
 </dd>
</dl>
</div>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName("Web Animations", "#processing-a-keyframes-argument", "Keyframe object formats")}}</td>
   <td>{{Spec2('Web Animations')}}</td>
   <td>Initial definition</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<h3 id="Element.animate"><code>Element.animate</code></h3>

<div>

<p>{{Compat("api.Element.animate")}}</p>
</div>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/API/Web_Animations_API">Web Animations API</a></li>
 <li>{{domxref("Element.animate()")}}</li>
 <li>{{domxref("KeyframeEffect.KeyframeEffect()")}}</li>
 <li>{{domxref("KeyframeEffect.setKeyframes()")}}</li>
</ul>
